package com.friday.custody.dao;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.friday.custody.entity.CustShareSeqInfoEntity;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 基金持有份额变化流水表
 * 
 * @author lyb
 * @email k0051582@gmail.com
 * @date 2022-03-04 16:12:06
 */
@Mapper
public interface CustShareSeqInfoDao extends BaseMapper<CustShareSeqInfoEntity> {

    default Set<String> queryUniqueKeyList(List<String> rawUniqueKeyList){
        LambdaQueryWrapper<CustShareSeqInfoEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.select(CustShareSeqInfoEntity::getUniqueKey).in(CustShareSeqInfoEntity::getUniqueKey, rawUniqueKeyList);
        List<CustShareSeqInfoEntity> entityList = this.selectList(queryWrapper);
        Set<String> result = entityList.stream().map(t -> t.getUniqueKey()).collect(Collectors.toSet());
        return result;
    }

    default int deleteByUniqueKeys(Set<String> uniqueKeySet){
        LambdaQueryWrapper<CustShareSeqInfoEntity> queryWrapper = new LambdaQueryWrapper();
        queryWrapper.in(CustShareSeqInfoEntity::getUniqueKey, uniqueKeySet);
        return delete(queryWrapper);
    }
}
